package my;

/**
 * 都市クラスです。
 *
 * 国と都道府県、市区町村を持ちます。
 * 同値性は定義していません。
 */
public class MyCity {

    /** 国 */
    private final String country;
    /** 都道府県 */
    private final String prefecture;
    /** 市区町村 */
    private final String city;

    /**
     * 日本用のコンストラクタ
     *
     * @param prefecture 都道府県名
     * @param city       市区町村名
     */
    public MyCity(String prefecture, String city) {
        this("日本", prefecture, city);
    }

    /**
     * コンストラクタ
     *
     * @param country    国
     * @param prefecture 都道府県
     * @param city       市区町村
     */
    public MyCity(String country, String prefecture, String city) {
        this.country = country;
        this.prefecture = prefecture;
        this.city = city;
    }

    public String getCity() {
        return city;
    }

    public String getPrefecture() {
        return prefecture;
    }

    public String getCountry() {
        return country;
    }
}
