package my;

import java.util.List;
import java.util.stream.Collectors;
import java.util.stream.Stream;

/**
 * コレクションのテストで使用する、政令指定都市のリストを生成するクラスです。
 */
public class OrdinanceDesignatedCities {

    public static List<MyCity> get() throws Exception {
        return Stream.of(
                new MyCity("北海道", "札幌市"),
                new MyCity("宮城県", "仙台市"),
                new MyCity("埼玉県", "さいたま市"),
                new MyCity("千葉県", "千葉市"),
                new MyCity("神奈川県", "横浜市"),
                new MyCity("神奈川県", "川崎市"),
                new MyCity("神奈川県", "相模原市"),
                new MyCity("新潟県", "新潟市"),
                new MyCity("静岡県", "静岡市"),
                new MyCity("静岡県", "浜松市"),
                new MyCity("愛知県", "名古屋市"),
                new MyCity("京都府", "京都市"),
                new MyCity("大阪府", "大阪市"),
                new MyCity("大阪府", "堺市"),
                new MyCity("兵庫県", "神戸市"),
                new MyCity("岡山県", "岡山市"),
                new MyCity("広島県", "広島市"),
                new MyCity("福岡県", "福岡市"),
                new MyCity("福岡県", "北九州市"),
                new MyCity("熊本県", "熊本市"))
                .sorted((o1, o2) -> {
                    // 雑に名前でソートしておく
                    if (o1.getCountry().equals(o2.getCountry())) {
                        if (o1.getPrefecture().equals(o2.getPrefecture())) {
                            return o1.getCity().compareTo(o2.getCity());
                        }
                        return o1.getPrefecture().compareTo(o2.getPrefecture());
                    }
                    return o1.getCountry().compareTo(o2.getCountry());
                })
                .collect(Collectors.toList());
    }
}
