package my;

import org.assertj.core.api.AbstractAssert;
import org.assertj.core.util.Objects;

/**
 * ジェネレーターで生成したAssertのサンプルコードです。
 *
 * {@link MyCity} specific assertions - Generated by CustomAssertionGenerator.
 */
public class MyCityAssert extends AbstractAssert<MyCityAssert, MyCity> {

    /**
     * Creates a new <code>{@link MyCityAssert}</code> to make assertions on actual MyCity.
     *
     * @param actual the MyCity we want to make assertions on.
     */
    public MyCityAssert(MyCity actual) {
        super(actual, MyCityAssert.class);
    }

    /**
     * An entry point for MyCityAssert to follow AssertJ standard <code>assertThat()</code> statements.<br>
     * With a static import, one can write directly: <code>assertThat(myMyCity)</code> and get specific assertion with code completion.
     *
     * @param actual the MyCity we want to make assertions on.
     * @return a new <code>{@link MyCityAssert}</code>
     */
    public static MyCityAssert assertThat(MyCity actual) {
        return new MyCityAssert(actual);
    }

    /**
     * Verifies that the actual MyCity's city is equal to the given one.
     *
     * @param city the given city to compare the actual MyCity's city to.
     * @return this assertion object.
     * @throws AssertionError - if the actual MyCity's city is not equal to the given one.
     */
    public MyCityAssert hasCity(String city) {
        // check that actual MyCity we want to make assertions on is not null.
        isNotNull();

        // overrides the default error message with a more explicit one
        String assertjErrorMessage = "\nExpecting city of:\n  <%s>\nto be:\n  <%s>\nbut was:\n  <%s>";

        // null safe check
        String actualCity = actual.getCity();
        if (!Objects.areEqual(actualCity, city)) {
            //failWithMessage(assertjErrorMessage, actual, city, actualCity);
            failWithMessage("市の名前が期待はずれだよ");
        }

        // return the current assertion for method chaining
        return this;
    }

    /**
     * Verifies that the actual MyCity's country is equal to the given one.
     *
     * @param country the given country to compare the actual MyCity's country to.
     * @return this assertion object.
     * @throws AssertionError - if the actual MyCity's country is not equal to the given one.
     */
    public MyCityAssert hasCountry(String country) {
        // check that actual MyCity we want to make assertions on is not null.
        isNotNull();

        // overrides the default error message with a more explicit one
        String assertjErrorMessage = "\nExpecting country of:\n  <%s>\nto be:\n  <%s>\nbut was:\n  <%s>";

        // null safe check
        String actualCountry = actual.getCountry();
        if (!Objects.areEqual(actualCountry, country)) {
            failWithMessage(assertjErrorMessage, actual, country, actualCountry);
        }

        // return the current assertion for method chaining
        return this;
    }

    /**
     * Verifies that the actual MyCity's prefecture is equal to the given one.
     *
     * @param prefecture the given prefecture to compare the actual MyCity's prefecture to.
     * @return this assertion object.
     * @throws AssertionError - if the actual MyCity's prefecture is not equal to the given one.
     */
    public MyCityAssert hasPrefecture(String prefecture) {
        // check that actual MyCity we want to make assertions on is not null.
        isNotNull();

        // overrides the default error message with a more explicit one
        String assertjErrorMessage = "\nExpecting prefecture of:\n  <%s>\nto be:\n  <%s>\nbut was:\n  <%s>";

        // null safe check
        String actualPrefecture = actual.getPrefecture();
        if (!Objects.areEqual(actualPrefecture, prefecture)) {
            failWithMessage(assertjErrorMessage, actual, prefecture, actualPrefecture);
        }

        // return the current assertion for method chaining
        return this;
    }

}
