package my;

import org.hamcrest.Description;
import org.hamcrest.Factory;
import org.hamcrest.TypeSafeMatcher;

/**
 * HamcrestのカスタムMatcherのサンプルコードです。
 */
public class MyCityNameMatcher extends TypeSafeMatcher<MyCity> {

    private final String name;

    private MyCityNameMatcher(String name) {
        this.name = name;
    }

    @Override
    protected boolean matchesSafely(MyCity item) {
        return name.equals(item.getCity());
    }

    @Override
    public void describeTo(Description description) {
        description.appendText("city is ");
        description.appendValue(name);
    }

    @Factory
    public static MyCityNameMatcher city(String name) {
        return new MyCityNameMatcher(name);
    }
}
