package sample;

import org.junit.Test;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

import static org.hamcrest.CoreMatchers.is;
import static org.hamcrest.CoreMatchers.startsWith;
import static org.junit.Assert.assertThat;
import static org.junit.Assert.assertTrue;

/**
 * 「アサーションとテスティングフレームワーク」と
 * 「アサーションAPIに求められること」のサンプルコードです。
 */
public class Section1_2 {

    @Test
    public void assert文() throws Exception {
        List<?> list = Collections.emptyList();

        assert !list.isEmpty() : "リストが空です";
    }

    @Test
    public void AssertionErrorを自分で投げる() throws Exception {
        List<?> list = Collections.emptyList();

        if (list.isEmpty()) {
            throw new AssertionError("リストが空です");
        }
    }

    @Test
    public void 例外メッセージにリストの要素を表示する() throws Exception {
        List<?> list = Arrays.asList("hoge", "fuga");

        if (!list.isEmpty()) {
            throw new AssertionError(
                    "リストが空ではなく、" + list + "が設定されていました。");
        }
    }

    @Test
    public void JUnitのassertTrue() throws Exception {
        List<?> list = Arrays.asList("hoge", "fuga");

        assertTrue("リストが空ではありません", list.isEmpty());
    }

    @Test
    public void Hamcrestを使用するJUnitのassertThat() throws Exception {
        String str = "実際の文字列";

        assertThat(str, is(startsWith("期待")));
    }
}
