package sample;

import org.junit.Test;

import static org.assertj.core.api.Assertions.assertThat;

/**
 * 「AssertJとは」と
 * 「AssertJを使ってみよう」、
 * 「流れるようなアサーション」の最初のサンプルコードです。
 */
public class Section3_4_5 {

    @Test
    public void AssertJとは() throws Exception {
        String str = "実際の文字列";

        assertThat(str).startsWith("期待");
    }

    @Test
    public void AssertJを使ってみよう() throws Exception {
        String str = "期待する文字列";

        assertThat(str)
                .startsWith("期待")
                .hasSize(7)
                .contains("する", "文字")
                .containsPattern("する.{3}$")
                .doesNotEndWith("文字");
    }

    @Test
    public void 流れるようなアサーション() throws Exception {
        String str = "AssertJで流暢なアサーション";

        assertThat(str)
                .startsWith("AssertJ")
                .contains("流暢")
                .hasSize(17);
    }
}
