package sample;

import my.MyCity;
import org.junit.Test;

import static org.assertj.core.api.Assertions.assertThat;

/**
 * 「流れるようなアサーション プロパティを検証しよう」のサンプルコードです。
 */
public class Section5PropertyTest {

    @Test
    public void プロパティ名と値のセットをチェインして検証する() throws Exception {
        MyCity actual = new MyCity("大阪府", "大阪市");

        assertThat(actual)
                .hasFieldOrPropertyWithValue("prefecture", "大阪府")
                .hasFieldOrPropertyWithValue("city", "大阪市");
    }

    @Test
    public void ラムダ式でまとめて指定して配列として検証する() throws Exception {
        MyCity actual = new MyCity("大阪府", "大阪市");

        assertThat(actual)
                .extracting(MyCity::getPrefecture, MyCity::getCity)
                .containsExactly("大阪府", "大阪市");
    }
}
