package sample;

import my.MyCity;
import my.Prefecture;
import org.assertj.core.api.Condition;
import org.junit.Test;

import static org.assertj.core.api.Assertions.assertThat;

/**
 * 「もっと柔軟に検証するには 検証条件の実装」のサンプルコードです。
 */
public class Section6ConditionTest {

    @Test
    public void AssertJ固有のConditionで条件とメッセージを実装する() throws Exception {
        MyCity actual = new MyCity("大阪府", "堺市");

        class 近畿地方である extends Condition<MyCity> {

            @Override
            public boolean matches(MyCity city) {
                return Prefecture.isKinki(city);
            }
        }

        assertThat(actual).is(new 近畿地方である());
    }

    @Test
    public void Java標準のPredicateで条件のみ実装する() throws Exception {
        MyCity actual = new MyCity("大阪府", "堺市");

        assertThat(actual)
                .matches(Prefecture::isKinki);
        assertThat(actual)
                .matches(Prefecture::isKinki, "近畿地方");
    }
}
