package sample;

import my.MyCity;
import my.MyCityAssert;
import my.OrdinanceDesignatedCities;
import org.junit.Test;

import java.util.List;

import static my.MyProjectAssertions.assertThat;

/**
 * 「もっと柔軟に検証するには Assertionの作成」のサンプルコードです。
 */
public class Section6CustomAssertTest {

    @Test
    public void 作成したAssertを直接使用する() throws Exception {
        MyCity actual = new MyCity("大阪府", "大阪市");

        assertThat(actual)
                .hasCountry("日本")
                .hasPrefecture("大阪府")
                .hasCity("大阪市");
    }

    @Test
    public void 作成したAssertをListAssertを通して使用する() throws Exception {
        List<MyCity> actual = OrdinanceDesignatedCities.get();

        assertThat(actual, MyCityAssert.class)
                .hasSize(20)
                .first()
                .hasPrefecture("京都府")
                .hasCity("京都市");
    }
}
